bl_info = {
    "name": "Real time paths",
    "author": "Hamdi",
    "description" : "More free stuff for Blender: https://t.me/cgplugin",
    "blender": (4, 1, 0),
    "version": (1, 0, 0),
    "location": "Graph Editor ",
    "warning" : "this addon is for all devices and complex rigs",
    "category": "Animation",
}


import bpy
import bpy.utils.previews


addon_keymaps = {}
_icons = None
class SNA_PT_MOTION_PATHS_882F1(bpy.types.Panel):
    bl_label = 'Motion_paths'
    bl_idname = 'SNA_PT_MOTION_PATHS_882F1'
    bl_space_type = 'GRAPH_EDITOR'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Real_Time_Paths'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        row_6D555 = layout.row(heading='', align=False)
        row_6D555.alert = False
        row_6D555.enabled = True
        row_6D555.active = True
        row_6D555.use_property_split = False
        row_6D555.use_property_decorate = False
        row_6D555.scale_x = 1.0
        row_6D555.scale_y = 1.119999885559082
        row_6D555.alignment = 'Expand'.upper()
        row_6D555.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_6D555.operator('object.paths_calculate', text='Path_tracker', icon_value=878, emboss=True, depress=False)
        op = row_6D555.operator('pose.paths_calculate', text='Path_Bone', icon_value=882, emboss=True, depress=False)
        row_A53EB = layout.row(heading='', align=False)
        row_A53EB.alert = False
        row_A53EB.enabled = True
        row_A53EB.active = True
        row_A53EB.use_property_split = False
        row_A53EB.use_property_decorate = False
        row_A53EB.scale_x = 1.0
        row_A53EB.scale_y = 1.0
        row_A53EB.alignment = 'Expand'.upper()
        row_A53EB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_A53EB.operator('sna.delet_path_6e947', text='', icon_value=907, emboss=True, depress=False)
        op = row_A53EB.operator('object.paths_update_visible', text='UPdate_Path', icon_value=918, emboss=True, depress=False)
        op = row_A53EB.operator('sna.delet_allpath_b6bbf', text='', icon_value=889, emboss=True, depress=False)


class SNA_OT_Delet_Path_6E947(bpy.types.Operator):
    bl_idname = "sna.delet_path_6e947"
    bl_label = "delet_path"
    bl_description = "delete all path from selected bone or object"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        # Check if there is an active object and it is in pose mode
        if bpy.context.active_object and bpy.context.active_object.mode == 'POSE':
            # Clear paths in pose mode
            bpy.ops.pose.paths_clear(only_selected=True)
        # Check if there is an active object
        if bpy.context.active_object:
            # Clear paths in object mode   
            bpy.ops.object.paths_clear(only_selected=True)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Delet_Allpath_B6Bbf(bpy.types.Operator):
    bl_idname = "sna.delet_allpath_b6bbf"
    bl_label = "Delet_All-path"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        # Check if there is an active object and it is in pose mode
        if bpy.context.active_object and bpy.context.active_object.mode == 'POSE':
            # Clear paths in pose mode
            bpy.ops.pose.paths_clear(only_selected=False)
        # Check if there is an active object
        if bpy.context.active_object:
            # Clear paths in object mode
            bpy.ops.object.paths_clear(only_selected=False)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)



class AMTH_OT_AutoUpdateMotionPaths(bpy.types.Operator):
    """Auto-update motion paths after keyframe movement"""
    bl_idname = "amth.auto_update_motion_paths"
    bl_label = "Auto Update Motion Paths (Improved)"
    bl_options = {'REGISTER', 'UNDO'}

    _timer = None
    _last_active_keyframe_values = None  # Track the values of the last active keyframe
    _needs_update = False  # Flag to indicate update needed

    @classmethod
    def poll(cls, context):
        return context.area.type == 'GRAPH_EDITOR'

    def invoke(self, context, event):
        wm = context.window_manager
        self._last_active_keyframe_values = self._get_active_keyframe_values(context)
        self._needs_update = False  # Reset update flag

        if wm.update_mode == 'TIMER':
            self._timer = wm.event_timer_add(wm.auto_update_timer_interval, window=context.window)
        context.window_manager.modal_handler_add(self)
        return {'RUNNING_MODAL'}

    def modal(self, context, event):
        wm = context.window_manager

        if wm.update_mode == 'TIMER' and event.type == 'TIMER':
            active_keyframe_values = self._get_active_keyframe_values(context)
            if active_keyframe_values != self._last_active_keyframe_values:
                self._needs_update = True
        elif wm.update_mode == 'EVENT':
            active_keyframe_values = self._get_active_keyframe_values(context)
            if active_keyframe_values != self._last_active_keyframe_values:
                self._needs_update = True

        if self._needs_update:
            try:
                bpy.ops.object.paths_update_visible()  # Update motion paths
            except Exception as e:
                print("Error updating motion paths:", e)
            self._last_active_keyframe_values = active_keyframe_values
            self._needs_update = False  # Reset flag after update

        if not wm.auto_update_active:
            self.cancel(context)
            return {'CANCELLED'}

        return {'PASS_THROUGH'}

    def cancel(self, context):
        wm = context.window_manager
        if self._timer:
            wm.event_timer_remove(self._timer)
            self._timer = None

    def _get_active_keyframes(self, context):
        active_object = context.active_object
        active_action = active_object.animation_data.action if active_object and active_object.animation_data else None
        if not active_action:
            return []

        active_keyframes = []
        for fcurve in active_action.fcurves:
            for keyframe in fcurve.keyframe_points:
                if keyframe.select_control_point:
                    active_keyframes.append(keyframe)
        return active_keyframes

    def _get_active_keyframe_values(self, context):
        active_keyframes = self._get_active_keyframes(context)
        if active_keyframes:
            return [(keyframe.co[0], keyframe.co[1]) for keyframe in active_keyframes]
        return None


class AMTH_OT_AutoUpdateActivate(bpy.types.Operator):
    bl_idname = "amth.auto_update_activate"
    bl_label = "Activate Auto Update"
    bl_icon = 'PLAY'

    def execute(self, context):
        context.window_manager.auto_update_active = True
        bpy.ops.amth.auto_update_motion_paths('INVOKE_DEFAULT')
        return {'FINISHED'}


class AMTH_OT_AutoUpdateDeactivate(bpy.types.Operator):
    bl_idname = "amth.auto_update_deactivate"
    bl_label = "Deactivate Auto Update"
    bl_icon = 'PAUSE'
    
    def execute(self, context):
        context.window_manager.auto_update_active = False
        return {'FINISHED'}


class AMTH_PT_AutoUpdatePanel(bpy.types.Panel):
    bl_label = "Auto Update Motion Paths"
    bl_idname = "AMTH_PT_auto_update_panel"
    bl_space_type = 'GRAPH_EDITOR'
    bl_region_type = 'UI'
    bl_category = "Real_Time_Paths"

    def draw(self, context):
        layout = self.layout

        wm = context.window_manager

        layout.prop(wm, "update_mode", text="Update Mode")
        if wm.update_mode == 'TIMER':
            layout.prop(wm, "auto_update_timer_interval", text="Timer Interval")

        if not wm.auto_update_active:
            layout.operator("amth.auto_update_activate", text="Activate Auto Update", icon='PLAY')
        else:
            layout.operator("amth.auto_update_deactivate", text="Deactivate Auto Update", icon='PAUSE')


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_PT_MOTION_PATHS_882F1)
    bpy.utils.register_class(SNA_OT_Delet_Path_6E947)
    bpy.utils.register_class(SNA_OT_Delet_Allpath_B6Bbf)

    bpy.types.WindowManager.auto_update_active = bpy.props.BoolProperty(default=False)
    bpy.types.WindowManager.auto_update_timer_interval = bpy.props.FloatProperty(
        name="Timer Interval",
        description="Interval in seconds for the auto-update timer",
        default=0.1,
        min=0.1,
        max=1.0
    )
    bpy.types.WindowManager.update_mode = bpy.props.EnumProperty(
        name="Update Mode",
        description="Choose between timer-based and event-based update modes",
        items=[
            ('TIMER', "Real_Time", "Update motion paths in real time Suitable for medium or powerfull devices"),
            ('EVENT', "After_Change", "Update motion paths after moving the keyframes Suitable for weak devices")
        ],
        default='EVENT'
    )

    for cls in [AMTH_OT_AutoUpdateMotionPaths, AMTH_OT_AutoUpdateActivate, AMTH_OT_AutoUpdateDeactivate, AMTH_PT_AutoUpdatePanel]:
        bpy.utils.register_class(cls)

def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_PT_MOTION_PATHS_882F1)
    bpy.utils.unregister_class(SNA_OT_Delet_Path_6E947)
    bpy.utils.unregister_class(SNA_OT_Delet_Allpath_B6Bbf)

    for cls in [AMTH_OT_AutoUpdateMotionPaths, AMTH_OT_AutoUpdateActivate, AMTH_OT_AutoUpdateDeactivate, AMTH_PT_AutoUpdatePanel]:
        bpy.utils.unregister_class(cls)
    del bpy.types.WindowManager.auto_update_active
    del bpy.types.WindowManager.auto_update_timer_interval
    del bpy.types.WindowManager.update_mode


